EDIT - bug #7874

TeamOrPersonBase entity can become unusable due to replacement of the title caches on using
getters

10/26/2018 01:44 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Mller % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.5

Severity: critical Found in Version:

Description

This issue is quite good explainable by the case examined in #7870#note-1 :

The initial problem is cause by the protectedNomenclaturalTitleCache flag of the Team being set to false. When binding the data to
the Ul the getNomenclaturalTitle() is called which causes the the nomenclaturalTitle being updated using the cache strategy. The
value stored in the db is now different from the value contained in the nomenclaturalTitle-field:

nomenclaturalTitle in db:

Turland, Wiersema, Barrie, Greuter, D.Hawksw., Herend., S.Knapp, Kusber, D.Z.Li, Marhold, T.W.May,
McNeill, A.M.Monro, J.Prado, M.J.Price & Gideon F.Sm.

nomenclaturalTitle in loaded entity:
Turland, Wiersema, Barrie, Greuter, D.Hawksw., Herend., S.Knapp, Kusber, D.Z.Li, Marhold, T.W.May,
McNeill, Monro, A.M., J.Prado, M.J.Price & Gideon F.Sm.

The Team entity is loaded as part of the object graph which belongs to the reference. The submitter has no UPDATE permission for
this Team. But saving the Reference will cause the Team being flushed to the data base. However the getter has changed the value
of the nomenclaturalTitle-field and the user is required to have the UPDATE permission and a PermissionDeniedException is thrown.

One could now point out that the Team is in an inconsistent state since the nomenclaturalTitle differs from the value generated by the
cache even if the protectedNomenclaturalTitleCache value is is false. But is seems as if this Team has been created by user henning
manually using the Taxeditor (last updated on 2018-04-24 16:52:32). So this is not an import issue.

Either the Taxeditor must never leave Teams in such an inconsistent state or we need to find a way do deal with these situations in
the entity class and/or during the flush operation.

This is really critical since it blocks underprivileged users from using object without having the UPDPATE permission.

Related issues:

Related to EDIT - bug #9683: Auto-initialize root bean Closed
Related to EDIT - bug #9684: OccurrenceServicelmpl.listRootUnitDTOsByAssociat... Closed
Related to EDIT - feature request #9664: Add nomenclaturalTitleCache to TeamO... Resolved
Copied from EDIT - bug #7870: RegistrationWorkingsetEditor: Internal error on... Closed
Copied to EDIT - feature request #8030: Cache updater service methods externa... Closed

Associated revisions

Revision cfcf723b - 10/26/2018 05:40 PM - Andreas Kohlbecker
fix #7874 updating also the nomenclaturalTitle in updateTitleCacheForSingleEntity()

Revision a55e93b5 - 01/29/2019 11:42 AM - Andreas Kohlbecker
ref #7874 test for nomenclaturalTitle cache updater and fixing problem in IdentifiableServiceBase

which prevented from running the updater when titleCache was protected

Revision c497656b - 02/01/2019 02:21 PM - Andreas Miiller

ref #7874 implement cache update for additional caches
Revision dfc93007 - 02/01/2019 02:26 PM - Andreas Miiller
ref #7874 added reference to ticket to test

Revision b4be3c3e - 02/12/2019 11:41 AM - Andreas Kohlbecker

ref #7874 adding missing testcase related to Person nomenclatural title genration

Revision 40a73ef7 - 02/13/2019 01:17 PM - Andreas Miiller

ref #7874 fix incorrect nomTitle test

Revision 694f0ef2 - 03/11/2019 12:12 PM - Katja Luther

fix #7874: updateCaches always returns true

Revision 2e1fd4da - 04/15/2019 03:53 PM - Katja Luther

fix #7874: updateCaches always returns true

History

#1 - 10/26/2018 01:44 PM - Andreas Kohlbecker

- Copied from bug #7870: RegistrationWorkingsetEditor: Internal error on clicking "new name" added

#2 - 10/26/2018 01:45 PM - Andreas Kohlbecker

AM:

ganz so kritisch ist es glaube ich nicht. Letztlich muss man nur den cache updaten mit dem Cacheupdater. Allerdings sollte man sich dabei vorher
ganz sicher sein, dass auch alle Daten, die NICHT protected sind richtig atomisiert vorliegen.

Das Problem kommt durch die Umstellung der TitleCaches auf Initials hinter dem Namen. Da die notTitles auch mit dem TitleCache geflllt werden,
wenn keine expliziten nomTitles vorliegen, werden die damit auch geandert.

Eigentlich soll auf allen DBs friher oder spater der Cacheupdater laufen. ABER: zumindest von Palmweb weif3 ich, dass es da noch Daten gibt, die
nicht protected sind und auch nicht atomisiert. Deswegen habe ich das noch verschoben, bis ich Zeit habe, die Daten vorher kurz zu checken.

Wie gesagt, wenn ihr euch bei Phycobank sicher seid, dass alles stimmt, sollte es kein Problem sein.
Ansonsten missen wir eben méglichst bals mal an das Cache Handling bzgl. Permissions ran wie kiirzlich besprochen (mit System Rechten und so)

#3 - 10/26/2018 01:56 PM - Andreas Kohlbecker

- Assignee changed from Andreas Mtiller to Andreas Kohlbecker

#4 - 10/26/2018 02:27 PM - Andreas Kohlbecker
- File agents.ods added

The Problem comes from the Person named "A.M. Monroe" which has been entered in the Taxeditor by Henning on 2018-04-24.
He was sure that he set the protectedNomenclaturalTile to FALSE before saving the entity. But the protected flags in the DB are all NULL (see
agents.ods). | would expect these field to be filled or is NULL the same as FALSE in the sense of the cdm protected-Flags?

#5 - 10/26/2018 04:07 PM - Andreas Miiller
Andreas Kohlbecker wrote:
The Problem comes from the Person named "A.M. Monroe" which has been entered in the Taxeditor by Henning on 2018-04-24.

He was sure that he set the protectedNomenclaturalTile to FALSE before saving the entity. But the protected flags in the DB are all NULL (see
agents.ods). | would expect these field to be filled or is NULL the same as FALSE in the sense of the cdm protected-Flags?

Persons do not have a protected flag on this field. Only teams.
#6 - 10/26/2018 05:39 PM - Andreas Kohlbecker
Running the CacheUpdater should fix the issue. But the method IdentifiableServiceBase.updateTitleCacheForSingleEntity() misses updating the

nomenclaturalTitle.

#7 - 10/26/2018 05:40 PM - Andreas Kohlbecker
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|cfcf723b6485a38d3b39e4d53696036d212d6d6c¢.
#8 - 10/26/2018 05:42 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Mtiller

please review

#9 - 01/25/2019 03:07 PM - Andreas Miiller

- Description updated

| don't understand why in line 414

if (!'team.isProtectedTitleCache ()) {
team.setProtectedNomenclaturalTitleCache (true);
oldNomenclaturalTitle = team.getNomenclaturalTitle();
team.setProtectedNomenclaturalTitleCache (false);

}

you test for protectedTitleCache but then you change the protected*NomenclaturalTitleCache

#10 - 01/25/2019 03:29 PM - Andreas Miiller

Generally at the moment | do not fully understand how far we need the lines after line 439. The call

entitiesToUpdate.add (entity);

is not really required | think as the entities all belong to the session already. If not, are the .getTitleCache or .getAbbrevTitleCace calls important here?
Or can we completely delete this part. If not | wonder why the calls are alternative, e.g. if olcTitleCache <> newTitleCache the entity instanceof Team

part is not called anymore. Is this on purpose?

Also the whole method is only called entity.isProtectedTitleCache() == false which might be unwanted e.g. for Teams. If the titleCache is protected but
nomenclaturalTitleCache is not protected we may still want to update it.

Generally we need to refactor this part and move away the specific class handling from IdentifiableServiceBase (e.g. we could move the update
routines to the model classes as the knowledge about the model classes is best here)

#11 - 01/25/2019 03:32 PM - Andreas Miiller

The above issue might be moved to a new ticket.

#12 - 01/25/2019 03:33 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Andreas Kohlbecker

Also a test might be nice to have to explain a bit more the problem and to make sure that even after reimplementation the given problem will be
solved.

There is a very short test for the method in IdentifiableServiceBaseTest already for general testing if the method works basically.

#13 - 01/29/2019 11:45 AM - Andreas Kohlbecker

| implemented a test in AgentServicelmplTest and found a bug in IdentifiableServiceBase which prevented from running the updater for
TemOrPersonBase when protectedTitleCache == true, this is fixed, see a55e93b5

All other improvements should go into another issue ....
#14 - 01/29/2019 11:48 AM - Andreas Kohlbecker
Andreas Muller wrote:
| don't understand why in line 414
if (!team.isProtectedTitleCache ()) {
team.setProtectedNomenclaturalTitleCache (true);
oldNomenclaturalTitle = team.getNomenclaturalTitle();
team.setProtectedNomenclaturalTitleCache (false);

}

you test for protectedTitleCache but then you change the protected*NomenclaturalTitleCache

fixed in a55e93b5
#15 - 01/29/2019 11:48 AM - Andreas Kohlbecker

- Copied to feature request #8030: Cache updater service methods externalized and base class specific added

#16 - 01/29/2019 11:49 AM - Andreas Kohlbecker

i suggest to close this issue now

#17 - 01/29/2019 11:49 AM - Andreas Kohlbecker
- Status changed from Feedback to Resolved
- Assignee changed from Andreas Kohlbecker to Andreas Miiller

- % Done changed from 50 to 60

#18 - 01/30/2019 10:41 AM - Andreas Kohlbecker

- Tags changed from phycobank to phycobank, permission

#19 - 02/01/2019 02:24 PM - Andreas Miiller

- Assignee changed from Andreas Muiller to Andreas Kohlbecker

ab5e93b5 was a bit to restricted only to Teams. Also it handled Persons not correct (they do not have an additional cache). | updated the code to

also be valid for other classes having additional caches. Please review.

#20 - 02/01/2019 06:53 PM - Andreas Kohlbecker
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Kohlbecker to Andreas Mliller

would't it be necessary to add the following to TeamOrPersonBase?

@Override

public boolean hasUnprotectedCache () {

return super.hasUnprotectedCache ()
|| !'isBlank (nomenclaturalTitle);

}
to make it work in all cases.
The getNomenclaturalTitle() method treats the nomenclaturalTitles if it was unprotected in case it is blank!
#21 - 02/12/2019 11:17 AM - Andreas Kohlbecker

- Category changed from cdm-vaadin to cdmlib

all commits went into cdmlib-model and cdmlib-service, adapting the category.
#22 - 02/12/2019 11:43 AM - Andreas Kohlbecker

Adding testcase which reproduces the bug mentioned in comment 20 b4be3c3e
IdentifiableServiceBase.updateTitleCachelmpl() fails with this assertion.

#23 - 02/13/2019 01:03 PM - Andreas Miiller

| do not understand this line in user tests:

assertEquals ("Expecting nomenclaturalTitle to be set since it was NULL",
ralTitleField.get (ehrenberqg)) ;

NomTitle should be "Ehrenb." (same as titleCache) then as if null it is always computed from the titleCache
#24 - 02/13/2019 01:45 PM - Andreas Kohlbecker
You are right! Sorry for this bug in the assertion. Please correct it to :
assertEquals (
"Expecting nomenclaturalTitle to be set since it was NULL",

"Ehrenb.",
nomenclaturalTitleField.get (ehrenberqg));
#25 - 02/13/2019 06:52 PM - Andreas Miiller
- Status changed from Feedback to Resolved

- Assignee changed from Andreas Miller to Andreas Kohlbecker

This should be fully fixed now with fixing #8030

#26 - 02/14/2019 08:55 AM - Andreas Kohlbecker
- Status changed from Resolved to Closed
- Assignee changed from Andreas Kohlbecker to Andreas Mliller

- % Done changed from 60 to 100

looks like fixed by 100%

#27 - 03/11/2019 12:13 PM - Katja Luther
fixed a small bug in updateCaches of Team.java which results in the result was always true. cdmlib|694f0ef28f3f91c41d59def17430069c806980ec.

#28 - 06/28/2021 11:27 AM - Andreas Miiller
- Related to bug #9683: Auto-initialize root bean added

#29 - 06/28/2021 11:36 AM - Andreas Miiller
- Related to bug #9684: OccurrenceServicelmpl.listRootUnitDTOsByAssociatedTaxon() - [UPDATE] not permitted for 'anonymousUser' added

#30 - 07/01/2021 04:27 PM - Andreas Miiller

- Related to feature request #9664: Add nomenclaturalTitleCache to TeamQOrPersonBase added

Files

agents.ods 13.4 KB 10/26/2018 Andreas Kohlbecker
